# Interface WebSocket

The `EventEmitter` class is defined and exposed by the `node:events` module:

    import { EventEmitter } from 'node:events';

All `EventEmitter`s emit the event `'newListener'` when new listeners are added and `'removeListener'` when existing listeners are removed.

It supports the following option:

#### Since

v0.1.26

interface WebSocket {
CLOSED: 3;
CLOSING: 2;
CONNECTING: 0;
OPEN: 1;
binaryType: "nodebuffer" | "arraybuffer" | "fragments";
bufferedAmount: number;
extensions: string;
isPaused: boolean;
onclose: null | ((event) => void);
onerror: null | ((event) => void);
onmessage: null | ((event) => void);
onopen: null | ((event) => void);
protocol: string;
readyState: 0 | 1 | 2 | 3;
url: string;
[captureRejectionSymbol]?<K>(error, event, ...args): void;
addEventListener(method, cb, options?): void;
addEventListener(method, cb, options?): void;
addEventListener(method, cb, options?): void;
addEventListener(method, cb, options?): void;
addListener(event, listener): this;
addListener(event, listener): this;
addListener(event, listener): this;
addListener(event, listener): this;
addListener(event, listener): this;
addListener(event, listener): this;
addListener(event, listener): this;
addListener(event, listener): this;
close(code?, data?): void;
emit<K>(eventName, ...args): boolean;
eventNames(): (string | symbol)[];
getMaxListeners(): number;
listenerCount<K>(eventName, listener?): number;
listeners<K>(eventName): Function[];
off(event, listener): this;
off(event, listener): this;
off(event, listener): this;
off(event, listener): this;
off(event, listener): this;
off(event, listener): this;
off(event, listener): this;
off(event, listener): this;
on(event, listener): this;
on(event, listener): this;
on(event, listener): this;
on(event, listener): this;
on(event, listener): this;
on(event, listener): this;
on(event, listener): this;
on(event, listener): this;
once(event, listener): this;
once(event, listener): this;
once(event, listener): this;
once(event, listener): this;
once(event, listener): this;
once(event, listener): this;
once(event, listener): this;
once(event, listener): this;
pause(): void;
ping(data?, mask?, cb?): void;
pong(data?, mask?, cb?): void;
prependListener<K>(eventName, listener): this;
prependOnceListener<K>(eventName, listener): this;
rawListeners<K>(eventName): Function[];
removeAllListeners(eventName?): this;
removeEventListener(method, cb): void;
removeEventListener(method, cb): void;
removeEventListener(method, cb): void;
removeEventListener(method, cb): void;
removeListener(event, listener): this;
removeListener(event, listener): this;
removeListener(event, listener): this;
removeListener(event, listener): this;
removeListener(event, listener): this;
removeListener(event, listener): this;
removeListener(event, listener): this;
removeListener(event, listener): this;
resume(): void;
send(data, cb?): void;
send(data, options, cb?): void;
setMaxListeners(n): this;
terminate(): void;
}

#### Hierarchy (view full)

- WebSocketAlias
  - WebSocket

- Defined in node_modules/@types/ws/index.d.ts:403
- Defined in node_modules/@types/ws/index.d.ts:404

#####
Index

### Properties

CLOSED
CLOSING
CONNECTING
OPEN
binaryType
bufferedAmount
extensions
isPaused
onclose
onerror
onmessage
onopen
protocol
readyState
url

### Methods

[captureRejectionSymbol]?
addEventListener
addListener
close
emit
eventNames
getMaxListeners
listenerCount
listeners
off
on
once
pause
ping
pong
prependListener
prependOnceListener
rawListeners
removeAllListeners
removeEventListener
removeListener
resume
send
setMaxListeners
terminate

## Properties

### `Readonly` CLOSED

CLOSED: 3

The connection is closed.

Inherited from WebSocketAlias.CLOSED

- Defined in node_modules/@types/ws/index.d.ts:70

### `Readonly` CLOSING

CLOSING: 2

The connection is in the process of closing.

Inherited from WebSocketAlias.CLOSING

- Defined in node_modules/@types/ws/index.d.ts:68

### `Readonly` CONNECTING

CONNECTING: 0

The connection is not yet open.

Inherited from WebSocketAlias.CONNECTING

- Defined in node_modules/@types/ws/index.d.ts:64

### `Readonly` OPEN

OPEN: 1

The connection is open and ready to communicate.

Inherited from WebSocketAlias.OPEN

- Defined in node_modules/@types/ws/index.d.ts:66

### binaryType

binaryType: "nodebuffer" | "arraybuffer" | "fragments"

Inherited from WebSocketAlias.binaryType

- Defined in node_modules/@types/ws/index.d.ts:49

### `Readonly` bufferedAmount

bufferedAmount: number

Inherited from WebSocketAlias.bufferedAmount

- Defined in node_modules/@types/ws/index.d.ts:50

### `Readonly` extensions

extensions: string

Inherited from WebSocketAlias.extensions

- Defined in node_modules/@types/ws/index.d.ts:51

### `Readonly` isPaused

isPaused: boolean

Indicates whether the websocket is paused

Inherited from WebSocketAlias.isPaused

- Defined in node_modules/@types/ws/index.d.ts:53

### onclose

onclose: null | ((event) => void)

#### Type declaration

- - (event): void

  - #### Parameters

    - event: CloseEvent

    #### Returns void

Inherited from WebSocketAlias.onclose

- Defined in node_modules/@types/ws/index.d.ts:74

### onerror

onerror: null | ((event) => void)

#### Type declaration

- - (event): void

  - #### Parameters

    - event: ErrorEvent

    #### Returns void

Inherited from WebSocketAlias.onerror

- Defined in node_modules/@types/ws/index.d.ts:73

### onmessage

onmessage: null | ((event) => void)

#### Type declaration

- - (event): void

  - #### Parameters

    - event: MessageEvent

    #### Returns void

Inherited from WebSocketAlias.onmessage

- Defined in node_modules/@types/ws/index.d.ts:75

### onopen

onopen: null | ((event) => void)

#### Type declaration

- - (event): void

  - #### Parameters

    - event: Event

    #### Returns void

Inherited from WebSocketAlias.onopen

- Defined in node_modules/@types/ws/index.d.ts:72

### `Readonly` protocol

protocol: string

Inherited from WebSocketAlias.protocol

- Defined in node_modules/@types/ws/index.d.ts:54

### `Readonly` readyState

readyState: 0 | 1 | 2 | 3

The current state of the connection

Inherited from WebSocketAlias.readyState

- Defined in node_modules/@types/ws/index.d.ts:56

### `Readonly` url

url: string

Inherited from WebSocketAlias.url

- Defined in node_modules/@types/ws/index.d.ts:61

## Methods

### `Optional` [captureRejectionSymbol]

- [captureRejectionSymbol]<K>(error, event, ...args): void

- #### Type Parameters

  - K

  #### Parameters

  - error: Error
  - event: string | symbol
  - `Rest` ...args: AnyRest

  #### Returns void

  Inherited from WebSocketAlias.[captureRejectionSymbol]

  - Defined in node_modules/@types/node/events.d.ts:135

### addEventListener

- addEventListener(method, cb, options?): void

- #### Parameters

  - method: "message"
  - cb: ((event) => void)
    - - (event): void

      - #### Parameters

        - event: MessageEvent

        #### Returns void

  - `Optional` options: EventListenerOptions

  #### Returns void

  Inherited from WebSocketAlias.addEventListener

  - Defined in node_modules/@types/ws/index.d.ts:115
- addEventListener(method, cb, options?): void

- #### Parameters

  - method: "close"
  - cb: ((event) => void)
    - - (event): void

      - #### Parameters

        - event: CloseEvent

        #### Returns void

  - `Optional` options: EventListenerOptions

  #### Returns void

  Inherited from WebSocketAlias.addEventListener

  - Defined in node_modules/@types/ws/index.d.ts:120
- addEventListener(method, cb, options?): void

- #### Parameters

  - method: "error"
  - cb: ((event) => void)
    - - (event): void

      - #### Parameters

        - event: ErrorEvent

        #### Returns void

  - `Optional` options: EventListenerOptions

  #### Returns void

  Inherited from WebSocketAlias.addEventListener

  - Defined in node_modules/@types/ws/index.d.ts:125
- addEventListener(method, cb, options?): void

- #### Parameters

  - method: "open"
  - cb: ((event) => void)
    - - (event): void

      - #### Parameters

        - event: Event

        #### Returns void

  - `Optional` options: EventListenerOptions

  #### Returns void

  Inherited from WebSocketAlias.addEventListener

  - Defined in node_modules/@types/ws/index.d.ts:130

### addListener

- addListener(event, listener): this

- Alias for `emitter.on(eventName, listener)`.

  #### Parameters

  - event: "close"
  - listener: ((code, reason) => void)
    - - (code, reason): void

      - #### Parameters

        - code: number
        - reason: Buffer

        #### Returns void

  #### Returns this

  #### Since

  v0.1.26

  Inherited from WebSocketAlias.addListener

  - Defined in node_modules/@types/ws/index.d.ts:178
- addListener(event, listener): this

- #### Parameters

  - event: "error"
  - listener: ((err) => void)
    - - (err): void

      - #### Parameters

        - err: Error

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.addListener

  - Defined in node_modules/@types/ws/index.d.ts:179
- addListener(event, listener): this

- #### Parameters

  - event: "upgrade"
  - listener: ((request) => void)
    - - (request): void

      - #### Parameters

        - request: IncomingMessage

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.addListener

  - Defined in node_modules/@types/ws/index.d.ts:180
- addListener(event, listener): this

- #### Parameters

  - event: "message"
  - listener: ((data, isBinary) => void)
    - - (data, isBinary): void

      - #### Parameters

        - data: RawData
        - isBinary: boolean

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.addListener

  - Defined in node_modules/@types/ws/index.d.ts:181
- addListener(event, listener): this

- #### Parameters

  - event: "open"
  - listener: (() => void)
    - - (): void

      - #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.addListener

  - Defined in node_modules/@types/ws/index.d.ts:182
- addListener(event, listener): this

- #### Parameters

  - event: "ping" | "pong"
  - listener: ((data) => void)
    - - (data): void

      - #### Parameters

        - data: Buffer

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.addListener

  - Defined in node_modules/@types/ws/index.d.ts:183
- addListener(event, listener): this

- #### Parameters

  - event: "unexpected-response"
  - listener: ((request, response) => void)
    - - (request, response): void

      - #### Parameters

        - request: ClientRequest
        - response: IncomingMessage

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.addListener

  - Defined in node_modules/@types/ws/index.d.ts:184
- addListener(event, listener): this

- #### Parameters

  - event: string | symbol
  - listener: ((...args) => void)
    - - (...args): void

      - #### Parameters

        - `Rest` ...args: any[]

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.addListener

  - Defined in node_modules/@types/ws/index.d.ts:188

### close

- close(code?, data?): void

- #### Parameters

  - `Optional` code: number
  - `Optional` data: string | Buffer

  #### Returns void

  Inherited from WebSocketAlias.close

  - Defined in node_modules/@types/ws/index.d.ts:85

### emit

- emit<K>(eventName, ...args): boolean

- Synchronously calls each of the listeners registered for the event named `eventName`, in the order they were registered, passing the supplied arguments to each.

  Returns `true` if the event had listeners, `false` otherwise.

      import { EventEmitter } from 'node:events';
      const myEmitter = new EventEmitter();

      // First listener
      myEmitter.on('event', function firstListener() {
        console.log('Helloooo! first listener');
      });
      // Second listener
      myEmitter.on('event', function secondListener(arg1, arg2) {
        console.log(`event with parameters ${arg1}, ${arg2} in second listener`);
      });
      // Third listener
      myEmitter.on('event', function thirdListener(...args) {
        const parameters = args.join(', ');
        console.log(`event with parameters ${parameters} in third listener`);
      });

      console.log(myEmitter.listeners('event'));

      myEmitter.emit('event', 1, 2, 3, 4, 5);

      // Prints:
      // [
      //   [Function: firstListener],
      //   [Function: secondListener],
      //   [Function: thirdListener]
      // ]
      // Helloooo! first listener
      // event with parameters 1, 2 in second listener
      // event with parameters 1, 2, 3, 4, 5 in third listener

  #### Type Parameters

  - K

  #### Parameters

  - eventName: string | symbol
  - `Rest` ...args: AnyRest

  #### Returns boolean

  #### Since

  v0.1.26

  Inherited from WebSocketAlias.emit

  - Defined in node_modules/@types/node/events.d.ts:837

### eventNames

- eventNames(): (string | symbol)[]

- Returns an array listing the events for which the emitter has registered listeners. The values in the array are strings or `Symbol`s.

      import { EventEmitter } from 'node:events';

      const myEE = new EventEmitter();
      myEE.on('foo', () => {});
      myEE.on('bar', () => {});

      const sym = Symbol('symbol');
      myEE.on(sym, () => {});

      console.log(myEE.eventNames());
      // Prints: [ 'foo', 'bar', Symbol(symbol) ]

  #### Returns (string | symbol)[]

  #### Since

  v6.0.0

  Inherited from WebSocketAlias.eventNames

  - Defined in node_modules/@types/node/events.d.ts:900

### getMaxListeners

- getMaxListeners(): number

- Returns the current max listener value for the `EventEmitter` which is either set by `emitter.setMaxListeners(n)` or defaults to defaultMaxListeners.

  #### Returns number

  #### Since

  v1.0.0

  Inherited from WebSocketAlias.getMaxListeners

  - Defined in node_modules/@types/node/events.d.ts:752

### listenerCount

- listenerCount<K>(eventName, listener?): number

- Returns the number of listeners listening for the event named `eventName`. If `listener` is provided, it will return how many times the listener is found in the list of the listeners of the event.

  #### Type Parameters

  - K

  #### Parameters

  - eventName: string | symbol

    The name of the event being listened for

  - `Optional` listener: Function

    The event handler function

  #### Returns number

  #### Since

  v3.2.0

  Inherited from WebSocketAlias.listenerCount

  - Defined in node_modules/@types/node/events.d.ts:846

### listeners

- listeners<K>(eventName): Function[]

- Returns a copy of the array of listeners for the event named `eventName`.

      server.on('connection', (stream) => {
        console.log('someone connected!');
      });
      console.log(util.inspect(server.listeners('connection')));
      // Prints: [ [Function] ]

  #### Type Parameters

  - K

  #### Parameters

  - eventName: string | symbol

  #### Returns Function[]

  #### Since

  v0.1.26

  Inherited from WebSocketAlias.listeners

  - Defined in node_modules/@types/node/events.d.ts:765

### off

- off(event, listener): this

- Alias for `emitter.removeListener()`.

  #### Parameters

  - event: "close"
  - listener: ((this, code, reason) => void)
    - - (this, code, reason): void

      - #### Parameters

        - this: WebSocket
        - code: number
        - reason: Buffer

        #### Returns void

  #### Returns this

  #### Since

  v10.0.0

  Inherited from WebSocketAlias.off

  - Defined in node_modules/@types/ws/index.d.ts:166
- off(event, listener): this

- #### Parameters

  - event: "error"
  - listener: ((this, err) => void)
    - - (this, err): void

      - #### Parameters

        - this: WebSocket
        - err: Error

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.off

  - Defined in node_modules/@types/ws/index.d.ts:167
- off(event, listener): this

- #### Parameters

  - event: "upgrade"
  - listener: ((this, request) => void)
    - - (this, request): void

      - #### Parameters

        - this: WebSocket
        - request: IncomingMessage

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.off

  - Defined in node_modules/@types/ws/index.d.ts:168
- off(event, listener): this

- #### Parameters

  - event: "message"
  - listener: ((this, data, isBinary) => void)
    - - (this, data, isBinary): void

      - #### Parameters

        - this: WebSocket
        - data: RawData
        - isBinary: boolean

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.off

  - Defined in node_modules/@types/ws/index.d.ts:169
- off(event, listener): this

- #### Parameters

  - event: "open"
  - listener: ((this) => void)
    - - (this): void

      - #### Parameters

        - this: WebSocket

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.off

  - Defined in node_modules/@types/ws/index.d.ts:170
- off(event, listener): this

- #### Parameters

  - event: "ping" | "pong"
  - listener: ((this, data) => void)
    - - (this, data): void

      - #### Parameters

        - this: WebSocket
        - data: Buffer

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.off

  - Defined in node_modules/@types/ws/index.d.ts:171
- off(event, listener): this

- #### Parameters

  - event: "unexpected-response"
  - listener: ((this, request, response) => void)
    - - (this, request, response): void

      - #### Parameters

        - this: WebSocket
        - request: ClientRequest
        - response: IncomingMessage

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.off

  - Defined in node_modules/@types/ws/index.d.ts:172
- off(event, listener): this

- #### Parameters

  - event: string | symbol
  - listener: ((this, ...args) => void)
    - - (this, ...args): void

      - #### Parameters

        - this: WebSocket
        - `Rest` ...args: any[]

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.off

  - Defined in node_modules/@types/ws/index.d.ts:176

### on

- on(event, listener): this

- Adds the `listener` function to the end of the listeners array for the event named `eventName`. No checks are made to see if the `listener` has already been added. Multiple calls passing the same combination of `eventName` and `listener` will result in the `listener` being added, and called, multiple times.

      server.on('connection', (stream) => {
        console.log('someone connected!');
      });

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  By default, event listeners are invoked in the order they are added. The `emitter.prependListener()` method can be used as an alternative to add the event listener to the beginning of the listeners array.

      import { EventEmitter } from 'node:events';
      const myEE = new EventEmitter();
      myEE.on('foo', () => console.log('a'));
      myEE.prependListener('foo', () => console.log('b'));
      myEE.emit('foo');
      // Prints:
      //   b
      //   a

  #### Parameters

  - event: "close"

    The name of the event.

  - listener: ((this, code, reason) => void)

    The callback function

    - - (this, code, reason): void

      - #### Parameters

        - this: WebSocket
        - code: number
        - reason: Buffer

        #### Returns void

  #### Returns this

  #### Since

  v0.1.101

  Inherited from WebSocketAlias.on

  - Defined in node_modules/@types/ws/index.d.ts:142
- on(event, listener): this

- #### Parameters

  - event: "error"
  - listener: ((this, err) => void)
    - - (this, err): void

      - #### Parameters

        - this: WebSocket
        - err: Error

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.on

  - Defined in node_modules/@types/ws/index.d.ts:143
- on(event, listener): this

- #### Parameters

  - event: "upgrade"
  - listener: ((this, request) => void)
    - - (this, request): void

      - #### Parameters

        - this: WebSocket
        - request: IncomingMessage

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.on

  - Defined in node_modules/@types/ws/index.d.ts:144
- on(event, listener): this

- #### Parameters

  - event: "message"
  - listener: ((this, data, isBinary) => void)
    - - (this, data, isBinary): void

      - #### Parameters

        - this: WebSocket
        - data: RawData
        - isBinary: boolean

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.on

  - Defined in node_modules/@types/ws/index.d.ts:145
- on(event, listener): this

- #### Parameters

  - event: "open"
  - listener: ((this) => void)
    - - (this): void

      - #### Parameters

        - this: WebSocket

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.on

  - Defined in node_modules/@types/ws/index.d.ts:146
- on(event, listener): this

- #### Parameters

  - event: "ping" | "pong"
  - listener: ((this, data) => void)
    - - (this, data): void

      - #### Parameters

        - this: WebSocket
        - data: Buffer

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.on

  - Defined in node_modules/@types/ws/index.d.ts:147
- on(event, listener): this

- #### Parameters

  - event: "unexpected-response"
  - listener: ((this, request, response) => void)
    - - (this, request, response): void

      - #### Parameters

        - this: WebSocket
        - request: ClientRequest
        - response: IncomingMessage

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.on

  - Defined in node_modules/@types/ws/index.d.ts:148
- on(event, listener): this

- #### Parameters

  - event: string | symbol
  - listener: ((this, ...args) => void)
    - - (this, ...args): void

      - #### Parameters

        - this: WebSocket
        - `Rest` ...args: any[]

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.on

  - Defined in node_modules/@types/ws/index.d.ts:152

### once

- once(event, listener): this

- Adds a one-time `listener` function for the event named `eventName`. The next time `eventName` is triggered, this listener is removed and then invoked.

      server.once('connection', (stream) => {
        console.log('Ah, we have our first user!');
      });

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  By default, event listeners are invoked in the order they are added. The `emitter.prependOnceListener()` method can be used as an alternative to add the event listener to the beginning of the listeners array.

      import { EventEmitter } from 'node:events';
      const myEE = new EventEmitter();
      myEE.once('foo', () => console.log('a'));
      myEE.prependOnceListener('foo', () => console.log('b'));
      myEE.emit('foo');
      // Prints:
      //   b
      //   a

  #### Parameters

  - event: "close"

    The name of the event.

  - listener: ((this, code, reason) => void)

    The callback function

    - - (this, code, reason): void

      - #### Parameters

        - this: WebSocket
        - code: number
        - reason: Buffer

        #### Returns void

  #### Returns this

  #### Since

  v0.3.0

  Inherited from WebSocketAlias.once

  - Defined in node_modules/@types/ws/index.d.ts:154
- once(event, listener): this

- #### Parameters

  - event: "error"
  - listener: ((this, err) => void)
    - - (this, err): void

      - #### Parameters

        - this: WebSocket
        - err: Error

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.once

  - Defined in node_modules/@types/ws/index.d.ts:155
- once(event, listener): this

- #### Parameters

  - event: "upgrade"
  - listener: ((this, request) => void)
    - - (this, request): void

      - #### Parameters

        - this: WebSocket
        - request: IncomingMessage

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.once

  - Defined in node_modules/@types/ws/index.d.ts:156
- once(event, listener): this

- #### Parameters

  - event: "message"
  - listener: ((this, data, isBinary) => void)
    - - (this, data, isBinary): void

      - #### Parameters

        - this: WebSocket
        - data: RawData
        - isBinary: boolean

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.once

  - Defined in node_modules/@types/ws/index.d.ts:157
- once(event, listener): this

- #### Parameters

  - event: "open"
  - listener: ((this) => void)
    - - (this): void

      - #### Parameters

        - this: WebSocket

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.once

  - Defined in node_modules/@types/ws/index.d.ts:158
- once(event, listener): this

- #### Parameters

  - event: "ping" | "pong"
  - listener: ((this, data) => void)
    - - (this, data): void

      - #### Parameters

        - this: WebSocket
        - data: Buffer

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.once

  - Defined in node_modules/@types/ws/index.d.ts:159
- once(event, listener): this

- #### Parameters

  - event: "unexpected-response"
  - listener: ((this, request, response) => void)
    - - (this, request, response): void

      - #### Parameters

        - this: WebSocket
        - request: ClientRequest
        - response: IncomingMessage

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.once

  - Defined in node_modules/@types/ws/index.d.ts:160
- once(event, listener): this

- #### Parameters

  - event: string | symbol
  - listener: ((this, ...args) => void)
    - - (this, ...args): void

      - #### Parameters

        - this: WebSocket
        - `Rest` ...args: any[]

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.once

  - Defined in node_modules/@types/ws/index.d.ts:164

### pause

- pause(): void

- Pause the websocket causing it to stop emitting events. Some events can still be emitted after this is called, until all buffered data is consumed. This method is a noop if the ready state is `CONNECTING` or `CLOSED`.

  #### Returns void

  Inherited from WebSocketAlias.pause

  - Defined in node_modules/@types/ws/index.d.ts:107

### ping

- ping(data?, mask?, cb?): void

- #### Parameters

  - `Optional` data: any
  - `Optional` mask: boolean
  - `Optional` cb: ((err) => void)
    - - (err): void

      - #### Parameters

        - err: Error

        #### Returns void

  Inherited from WebSocketAlias.ping

  - Defined in node_modules/@types/ws/index.d.ts:86

### pong

- pong(data?, mask?, cb?): void

- #### Parameters

  - `Optional` data: any
  - `Optional` mask: boolean
  - `Optional` cb: ((err) => void)
    - - (err): void

      - #### Parameters

        - err: Error

        #### Returns void

  Inherited from WebSocketAlias.pong

  - Defined in node_modules/@types/ws/index.d.ts:87

### prependListener

- prependListener<K>(eventName, listener): this

- Adds the `listener` function to the beginning of the listeners array for the event named `eventName`. No checks are made to see if the `listener` has already been added. Multiple calls passing the same combination of `eventName` and `listener` will result in the `listener` being added, and called, multiple times.

      server.prependListener('connection', (stream) => {
        console.log('someone connected!');
      });

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  #### Type Parameters

  - K

  #### Parameters

  - eventName: string | symbol

    The name of the event.

  - listener: ((...args) => void)

    The callback function

    - - (...args): void

      - #### Parameters

        - `Rest` ...args: any[]

        #### Returns void

  #### Returns this

  #### Since

  v6.0.0

  Inherited from WebSocketAlias.prependListener

  - Defined in node_modules/@types/node/events.d.ts:864

### prependOnceListener

- prependOnceListener<K>(eventName, listener): this

- Adds a one-time `listener` function for the event named `eventName` to the beginning of the listeners array. The next time `eventName` is triggered, this listener is removed, and then invoked.

      server.prependOnceListener('connection', (stream) => {
        console.log('Ah, we have our first user!');
      });

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  #### Type Parameters

  - K

  #### Parameters

  - eventName: string | symbol

    The name of the event.

  - listener: ((...args) => void)

    The callback function

    - - (...args): void

      - #### Parameters

        - `Rest` ...args: any[]

        #### Returns void

  #### Returns this

  #### Since

  v6.0.0

  Inherited from WebSocketAlias.prependOnceListener

  - Defined in node_modules/@types/node/events.d.ts:880

### rawListeners

- rawListeners<K>(eventName): Function[]

- Returns a copy of the array of listeners for the event named `eventName`, including any wrappers (such as those created by `.once()`).

      import { EventEmitter } from 'node:events';
      const emitter = new EventEmitter();
      emitter.once('log', () => console.log('log once'));

      // Returns a new Array with a function `onceWrapper` which has a property
      // `listener` which contains the original listener bound above
      const listeners = emitter.rawListeners('log');
      const logFnWrapper = listeners[0];

      // Logs "log once" to the console and does not unbind the `once` event
      logFnWrapper.listener();

      // Logs "log once" to the console and removes the listener
      logFnWrapper();

      emitter.on('log', () => console.log('log persistently'));
      // Will return a new Array with a single function bound by `.on()` above
      const newListeners = emitter.rawListeners('log');

      // Logs "log persistently" twice
      newListeners[0]();
      emitter.emit('log');

  #### Type Parameters

  - K

  #### Parameters

  - eventName: string | symbol

  #### Returns Function[]

  #### Since

  v9.4.0

  Inherited from WebSocketAlias.rawListeners

  - Defined in node_modules/@types/node/events.d.ts:796

### removeAllListeners

- removeAllListeners(eventName?): this

- Removes all listeners, or those of the specified `eventName`.

  It is bad practice to remove listeners added elsewhere in the code, particularly when the `EventEmitter` instance was created by some other component or module (e.g. sockets or file streams).

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  #### Parameters

  - `Optional` eventName: string | symbol

  #### Returns this

  #### Since

  v0.1.26

  Inherited from WebSocketAlias.removeAllListeners

  - Defined in node_modules/@types/node/events.d.ts:736

### removeEventListener

- removeEventListener(method, cb): void

- #### Parameters

  - method: "message"
  - cb: ((event) => void)
    - - (event): void

      - #### Parameters

        - event: MessageEvent

        #### Returns void

  Inherited from WebSocketAlias.removeEventListener

  - Defined in node_modules/@types/ws/index.d.ts:136
- removeEventListener(method, cb): void

- #### Parameters

  - method: "close"
  - cb: ((event) => void)
    - - (event): void

      - #### Parameters

        - event: CloseEvent

        #### Returns void

  Inherited from WebSocketAlias.removeEventListener

  - Defined in node_modules/@types/ws/index.d.ts:137
- removeEventListener(method, cb): void

- #### Parameters

  - method: "error"
  - cb: ((event) => void)
    - - (event): void

      - #### Parameters

        - event: ErrorEvent

        #### Returns void

  Inherited from WebSocketAlias.removeEventListener

  - Defined in node_modules/@types/ws/index.d.ts:138
- removeEventListener(method, cb): void

- #### Parameters

  - method: "open"
  - cb: ((event) => void)
    - - (event): void

      - #### Parameters

        - event: Event

        #### Returns void

  Inherited from WebSocketAlias.removeEventListener

  - Defined in node_modules/@types/ws/index.d.ts:139

### removeListener

- removeListener(event, listener): this

- Removes the specified `listener` from the listener array for the event named `eventName`.

      const callback = (stream) => {
        console.log('someone connected!');
      };
      server.on('connection', callback);
      // ...
      server.removeListener('connection', callback);

  `removeListener()` will remove, at most, one instance of a listener from the listener array. If any single listener has been added multiple times to the listener array for the specified `eventName`, then `removeListener()` must be called multiple times to remove each instance.

  Once an event is emitted, all listeners attached to it at the time of emitting are called in order. This implies that any `removeListener()` or `removeAllListeners()` calls after emitting and before the last listener finishes execution will not remove them from`emit()` in progress. Subsequent events behave as expected.

      import { EventEmitter } from 'node:events';
      class MyEmitter extends EventEmitter {}
      const myEmitter = new MyEmitter();

      const callbackA = () => {
        console.log('A');
        myEmitter.removeListener('event', callbackB);
      };

      const callbackB = () => {
        console.log('B');
      };

      myEmitter.on('event', callbackA);

      myEmitter.on('event', callbackB);

      // callbackA removes listener callbackB but it will still be called.
      // Internal listener array at time of emit [callbackA, callbackB]
      myEmitter.emit('event');
      // Prints:
      //   A
      //   B

      // callbackB is now removed.
      // Internal listener array [callbackA]
      myEmitter.emit('event');
      // Prints:
      //   A

  Because listeners are managed using an internal array, calling this will change the position indices of any listener registered after the listener being removed. This will not impact the order in which listeners are called, but it means that any copies of the listener array as returned by the `emitter.listeners()` method will need to be recreated.

  When a single function has been added as a handler multiple times for a single event (as in the example below), `removeListener()` will remove the most recently added instance. In the example the `once('ping')` listener is removed:

      import { EventEmitter } from 'node:events';
      const ee = new EventEmitter();

      function pong() {
        console.log('pong');
      }

      ee.on('ping', pong);
      ee.once('ping', pong);
      ee.removeListener('ping', pong);

      ee.emit('ping');
      ee.emit('ping');

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  #### Parameters

  - event: "close"
  - listener: ((code, reason) => void)
    - - (code, reason): void

      - #### Parameters

        - code: number
        - reason: Buffer

        #### Returns void

  #### Returns this

  #### Since

  v0.1.26

  Inherited from WebSocketAlias.removeListener

  - Defined in node_modules/@types/ws/index.d.ts:190
- removeListener(event, listener): this

- #### Parameters

  - event: "error"
  - listener: ((err) => void)
    - - (err): void

      - #### Parameters

        - err: Error

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.removeListener

  - Defined in node_modules/@types/ws/index.d.ts:191
- removeListener(event, listener): this

- #### Parameters

  - event: "upgrade"
  - listener: ((request) => void)
    - - (request): void

      - #### Parameters

        - request: IncomingMessage

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.removeListener

  - Defined in node_modules/@types/ws/index.d.ts:192
- removeListener(event, listener): this

- #### Parameters

  - event: "message"
  - listener: ((data, isBinary) => void)
    - - (data, isBinary): void

      - #### Parameters

        - data: RawData
        - isBinary: boolean

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.removeListener

  - Defined in node_modules/@types/ws/index.d.ts:193
- removeListener(event, listener): this

- #### Parameters

  - event: "open"
  - listener: (() => void)
    - - (): void

      - #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.removeListener

  - Defined in node_modules/@types/ws/index.d.ts:194
- removeListener(event, listener): this

- #### Parameters

  - event: "ping" | "pong"
  - listener: ((data) => void)
    - - (data): void

      - #### Parameters

        - data: Buffer

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.removeListener

  - Defined in node_modules/@types/ws/index.d.ts:195
- removeListener(event, listener): this

- #### Parameters

  - event: "unexpected-response"
  - listener: ((request, response) => void)
    - - (request, response): void

      - #### Parameters

        - request: ClientRequest
        - response: IncomingMessage

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.removeListener

  - Defined in node_modules/@types/ws/index.d.ts:196
- removeListener(event, listener): this

- #### Parameters

  - event: string | symbol
  - listener: ((...args) => void)
    - - (...args): void

      - #### Parameters

        - `Rest` ...args: any[]

        #### Returns void

  #### Returns this

  Inherited from WebSocketAlias.removeListener

  - Defined in node_modules/@types/ws/index.d.ts:200

### resume

- resume(): void

- Make a paused socket resume emitting events. This method is a noop if the ready state is `CONNECTING` or `CLOSED`.

  #### Returns void

  Inherited from WebSocketAlias.resume

  - Defined in node_modules/@types/ws/index.d.ts:112

### send

- send(data, cb?): void

- #### Parameters

  - data: BufferLike
  - `Optional` cb: ((err?) => void)
    - - (err?): void

      - #### Parameters

        - `Optional` err: Error

        #### Returns void

  Inherited from WebSocketAlias.send

  - Defined in node_modules/@types/ws/index.d.ts:89
- send(data, options, cb?): void

- #### Parameters

  - data: BufferLike
  - options: {
    binary?: boolean;
    compress?: boolean;
    fin?: boolean;
    mask?: boolean;
    }

    - ##### `Optional` binary?: boolean

    - ##### `Optional` compress?: boolean

    - ##### `Optional` fin?: boolean

    - ##### `Optional` mask?: boolean

  - `Optional` cb: ((err?) => void)
    - - (err?): void

      - #### Parameters

        - `Optional` err: Error

        #### Returns void

  Inherited from WebSocketAlias.send

  - Defined in node_modules/@types/ws/index.d.ts:90

### setMaxListeners

- setMaxListeners(n): this

- By default `EventEmitter`s will print a warning if more than `10` listeners are added for a particular event. This is a useful default that helps finding memory leaks. The `emitter.setMaxListeners()` method allows the limit to be modified for this specific `EventEmitter` instance. The value can be set to `Infinity` (or `0`) to indicate an unlimited number of listeners.

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  #### Parameters

  - n: number

  #### Returns this

  #### Since

  v0.3.5

  Inherited from WebSocketAlias.setMaxListeners

  - Defined in node_modules/@types/node/events.d.ts:746

### terminate

- terminate(): void

- #### Returns void

  Inherited from WebSocketAlias.terminate

  - Defined in node_modules/@types/ws/index.d.ts:100